unit richmlf;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  op_class;

type
  TForm1 = class(TForm)
    RichEditDLL: TDLLServer;
    RichEditCall: TTaskServer;
    procedure RichEditCallExecute(Sender: TObject;
      const Args: array of TVarRec; var Retval: Pointer);
    procedure RichEditCallCloseQuery(Sender: TObject;
      var CanClose: Boolean);
    procedure RichEditCallGetAvailable(Sender: TObject;
      var IsAvailable: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses remain;
{$R *.DFM}

procedure TForm1.RichEditCallExecute(Sender: TObject;
  const Args: array of TVarRec; var Retval: Pointer);
var
 i:Integer;
begin
 {Check if not opened}
  For I:=0 To Application.ComponentCount - 1 do
   begin
    if Application.Components[I] is TMainForm Then Exit;
   end;
  MainForm := TMainForm.Create(Application);
  MainForm.FServer:=RichEditCall;
  MainForm.Show;
  RichEditCall.NotifyAvailable(False);
end;

procedure TForm1.RichEditCallCloseQuery(Sender: TObject;
  var CanClose: Boolean);
var
 I:Integer;
begin
  CanClose := False;
{Check if not opened and try to close}
  For I:=0 To Application.ComponentCount - 1 do
    if Application.Components[I] is TMainForm Then
     begin
       (Application.Components[I] as TForm).Close;
       Break;
     end;
  Application.ProcessMessages;
{Check if closed}
  For I:=0 To Application.ComponentCount - 1 do
    if Application.Components[I] is TMainForm Then
     Exit;
  CanClose := True;


end;

procedure TForm1.RichEditCallGetAvailable(Sender: TObject;
  var IsAvailable: Boolean);
var
 I:Integer;
begin
  IsAvailable := False;
  For I:=0 To Application.ComponentCount - 1 do
    if Application.Components[I] is TMainForm Then
     Exit;
  IsAvailable := True;

end;

initialization {added for modlib}
    OverPLAYMainForm := TForm1;
    MainForm := nil;

end.
